(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
  (global = global || self, factory(global.ReactEvoke = {}, global.React));
}(this, function (exports, React) { 'use strict';

  React = React && React.hasOwnProperty('default') ? React['default'] : React;

  function _typeof(obj) {
    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
      var info = gen[key](arg);
      var value = info.value;
    } catch (error) {
      reject(error);
      return;
    }

    if (info.done) {
      resolve(value);
    } else {
      Promise.resolve(value).then(_next, _throw);
    }
  }

  function _asyncToGenerator(fn) {
    return function () {
      var self = this,
          args = arguments;
      return new Promise(function (resolve, reject) {
        var gen = fn.apply(self, args);

        function _next(value) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
        }

        function _throw(err) {
          asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
        }

        _next(undefined);
      });
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _construct(Parent, args, Class) {
    if (isNativeReflectConstruct()) {
      _construct = Reflect.construct;
    } else {
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) _setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }

    return _construct.apply(null, arguments);
  }

  function _isNativeFunction(fn) {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  }

  function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !_isNativeFunction(Class)) return Class;

      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }

      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);

        _cache.set(Class, Wrapper);
      }

      function Wrapper() {
        return _construct(Class, arguments, _getPrototypeOf(this).constructor);
      }

      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
      return _setPrototypeOf(Wrapper, Class);
    };

    return _wrapNativeSuper(Class);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    }
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  function unwrapExports (x) {
  	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var reactIs_production_min = createCommonjsModule(function (module, exports) {
  Object.defineProperty(exports,"__esModule",{value:!0});
  var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?Symbol.for("react.memo"):
  60115,r=b?Symbol.for("react.lazy"):60116;function t(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case h:return a;default:return u}}case r:case q:case d:return u}}}function v(a){return t(a)===m}exports.typeOf=t;exports.AsyncMode=l;exports.ConcurrentMode=m;exports.ContextConsumer=k;exports.ContextProvider=h;exports.Element=c;exports.ForwardRef=n;
  exports.Fragment=e;exports.Lazy=r;exports.Memo=q;exports.Portal=d;exports.Profiler=g;exports.StrictMode=f;exports.Suspense=p;exports.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||"object"===typeof a&&null!==a&&(a.$$typeof===r||a.$$typeof===q||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n)};exports.isAsyncMode=function(a){return v(a)||t(a)===l};exports.isConcurrentMode=v;exports.isContextConsumer=function(a){return t(a)===k};
  exports.isContextProvider=function(a){return t(a)===h};exports.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};exports.isForwardRef=function(a){return t(a)===n};exports.isFragment=function(a){return t(a)===e};exports.isLazy=function(a){return t(a)===r};exports.isMemo=function(a){return t(a)===q};exports.isPortal=function(a){return t(a)===d};exports.isProfiler=function(a){return t(a)===g};exports.isStrictMode=function(a){return t(a)===f};
  exports.isSuspense=function(a){return t(a)===p};
  });

  unwrapExports(reactIs_production_min);
  var reactIs_production_min_1 = reactIs_production_min.typeOf;
  var reactIs_production_min_2 = reactIs_production_min.AsyncMode;
  var reactIs_production_min_3 = reactIs_production_min.ConcurrentMode;
  var reactIs_production_min_4 = reactIs_production_min.ContextConsumer;
  var reactIs_production_min_5 = reactIs_production_min.ContextProvider;
  var reactIs_production_min_6 = reactIs_production_min.Element;
  var reactIs_production_min_7 = reactIs_production_min.ForwardRef;
  var reactIs_production_min_8 = reactIs_production_min.Fragment;
  var reactIs_production_min_9 = reactIs_production_min.Lazy;
  var reactIs_production_min_10 = reactIs_production_min.Memo;
  var reactIs_production_min_11 = reactIs_production_min.Portal;
  var reactIs_production_min_12 = reactIs_production_min.Profiler;
  var reactIs_production_min_13 = reactIs_production_min.StrictMode;
  var reactIs_production_min_14 = reactIs_production_min.Suspense;
  var reactIs_production_min_15 = reactIs_production_min.isValidElementType;
  var reactIs_production_min_16 = reactIs_production_min.isAsyncMode;
  var reactIs_production_min_17 = reactIs_production_min.isConcurrentMode;
  var reactIs_production_min_18 = reactIs_production_min.isContextConsumer;
  var reactIs_production_min_19 = reactIs_production_min.isContextProvider;
  var reactIs_production_min_20 = reactIs_production_min.isElement;
  var reactIs_production_min_21 = reactIs_production_min.isForwardRef;
  var reactIs_production_min_22 = reactIs_production_min.isFragment;
  var reactIs_production_min_23 = reactIs_production_min.isLazy;
  var reactIs_production_min_24 = reactIs_production_min.isMemo;
  var reactIs_production_min_25 = reactIs_production_min.isPortal;
  var reactIs_production_min_26 = reactIs_production_min.isProfiler;
  var reactIs_production_min_27 = reactIs_production_min.isStrictMode;
  var reactIs_production_min_28 = reactIs_production_min.isSuspense;

  var reactIs_development = createCommonjsModule(function (module, exports) {



  if (process.env.NODE_ENV !== "production") {
    (function() {

  Object.defineProperty(exports, '__esModule', { value: true });

  // The Symbol used to tag the ReactElement-like types. If there is no native Symbol
  // nor polyfill, then a plain number is used for performance.
  var hasSymbol = typeof Symbol === 'function' && Symbol.for;

  var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
  var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
  var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
  var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
  var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
  var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
  var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace;
  var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
  var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
  var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
  var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
  var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
  var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;

  function isValidElementType(type) {
    return typeof type === 'string' || typeof type === 'function' ||
    // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
    type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE);
  }

  /**
   * Forked from fbjs/warning:
   * https://github.com/facebook/fbjs/blob/e66ba20ad5be433eb54423f2b097d829324d9de6/packages/fbjs/src/__forks__/warning.js
   *
   * Only change is we use console.warn instead of console.error,
   * and do nothing when 'console' is not supported.
   * This really simplifies the code.
   * ---
   * Similar to invariant but only logs a warning if the condition is not met.
   * This can be used to log issues in development environments in critical
   * paths. Removing the logging code for production environments will keep the
   * same logic and follow the same code paths.
   */

  var lowPriorityWarning = function () {};

  {
    var printWarning = function (format) {
      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var argIndex = 0;
      var message = 'Warning: ' + format.replace(/%s/g, function () {
        return args[argIndex++];
      });
      if (typeof console !== 'undefined') {
        console.warn(message);
      }
      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };

    lowPriorityWarning = function (condition, format) {
      if (format === undefined) {
        throw new Error('`lowPriorityWarning(condition, format, ...args)` requires a warning ' + 'message argument');
      }
      if (!condition) {
        for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
          args[_key2 - 2] = arguments[_key2];
        }

        printWarning.apply(undefined, [format].concat(args));
      }
    };
  }

  var lowPriorityWarning$1 = lowPriorityWarning;

  function typeOf(object) {
    if (typeof object === 'object' && object !== null) {
      var $$typeof = object.$$typeof;
      switch ($$typeof) {
        case REACT_ELEMENT_TYPE:
          var type = object.type;

          switch (type) {
            case REACT_ASYNC_MODE_TYPE:
            case REACT_CONCURRENT_MODE_TYPE:
            case REACT_FRAGMENT_TYPE:
            case REACT_PROFILER_TYPE:
            case REACT_STRICT_MODE_TYPE:
            case REACT_SUSPENSE_TYPE:
              return type;
            default:
              var $$typeofType = type && type.$$typeof;

              switch ($$typeofType) {
                case REACT_CONTEXT_TYPE:
                case REACT_FORWARD_REF_TYPE:
                case REACT_PROVIDER_TYPE:
                  return $$typeofType;
                default:
                  return $$typeof;
              }
          }
        case REACT_LAZY_TYPE:
        case REACT_MEMO_TYPE:
        case REACT_PORTAL_TYPE:
          return $$typeof;
      }
    }

    return undefined;
  }

  // AsyncMode is deprecated along with isAsyncMode
  var AsyncMode = REACT_ASYNC_MODE_TYPE;
  var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
  var ContextConsumer = REACT_CONTEXT_TYPE;
  var ContextProvider = REACT_PROVIDER_TYPE;
  var Element = REACT_ELEMENT_TYPE;
  var ForwardRef = REACT_FORWARD_REF_TYPE;
  var Fragment = REACT_FRAGMENT_TYPE;
  var Lazy = REACT_LAZY_TYPE;
  var Memo = REACT_MEMO_TYPE;
  var Portal = REACT_PORTAL_TYPE;
  var Profiler = REACT_PROFILER_TYPE;
  var StrictMode = REACT_STRICT_MODE_TYPE;
  var Suspense = REACT_SUSPENSE_TYPE;

  var hasWarnedAboutDeprecatedIsAsyncMode = false;

  // AsyncMode should be deprecated
  function isAsyncMode(object) {
    {
      if (!hasWarnedAboutDeprecatedIsAsyncMode) {
        hasWarnedAboutDeprecatedIsAsyncMode = true;
        lowPriorityWarning$1(false, 'The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
      }
    }
    return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
  }
  function isConcurrentMode(object) {
    return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
  }
  function isContextConsumer(object) {
    return typeOf(object) === REACT_CONTEXT_TYPE;
  }
  function isContextProvider(object) {
    return typeOf(object) === REACT_PROVIDER_TYPE;
  }
  function isElement(object) {
    return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
  }
  function isForwardRef(object) {
    return typeOf(object) === REACT_FORWARD_REF_TYPE;
  }
  function isFragment(object) {
    return typeOf(object) === REACT_FRAGMENT_TYPE;
  }
  function isLazy(object) {
    return typeOf(object) === REACT_LAZY_TYPE;
  }
  function isMemo(object) {
    return typeOf(object) === REACT_MEMO_TYPE;
  }
  function isPortal(object) {
    return typeOf(object) === REACT_PORTAL_TYPE;
  }
  function isProfiler(object) {
    return typeOf(object) === REACT_PROFILER_TYPE;
  }
  function isStrictMode(object) {
    return typeOf(object) === REACT_STRICT_MODE_TYPE;
  }
  function isSuspense(object) {
    return typeOf(object) === REACT_SUSPENSE_TYPE;
  }

  exports.typeOf = typeOf;
  exports.AsyncMode = AsyncMode;
  exports.ConcurrentMode = ConcurrentMode;
  exports.ContextConsumer = ContextConsumer;
  exports.ContextProvider = ContextProvider;
  exports.Element = Element;
  exports.ForwardRef = ForwardRef;
  exports.Fragment = Fragment;
  exports.Lazy = Lazy;
  exports.Memo = Memo;
  exports.Portal = Portal;
  exports.Profiler = Profiler;
  exports.StrictMode = StrictMode;
  exports.Suspense = Suspense;
  exports.isValidElementType = isValidElementType;
  exports.isAsyncMode = isAsyncMode;
  exports.isConcurrentMode = isConcurrentMode;
  exports.isContextConsumer = isContextConsumer;
  exports.isContextProvider = isContextProvider;
  exports.isElement = isElement;
  exports.isForwardRef = isForwardRef;
  exports.isFragment = isFragment;
  exports.isLazy = isLazy;
  exports.isMemo = isMemo;
  exports.isPortal = isPortal;
  exports.isProfiler = isProfiler;
  exports.isStrictMode = isStrictMode;
  exports.isSuspense = isSuspense;
    })();
  }
  });

  unwrapExports(reactIs_development);
  var reactIs_development_1 = reactIs_development.typeOf;
  var reactIs_development_2 = reactIs_development.AsyncMode;
  var reactIs_development_3 = reactIs_development.ConcurrentMode;
  var reactIs_development_4 = reactIs_development.ContextConsumer;
  var reactIs_development_5 = reactIs_development.ContextProvider;
  var reactIs_development_6 = reactIs_development.Element;
  var reactIs_development_7 = reactIs_development.ForwardRef;
  var reactIs_development_8 = reactIs_development.Fragment;
  var reactIs_development_9 = reactIs_development.Lazy;
  var reactIs_development_10 = reactIs_development.Memo;
  var reactIs_development_11 = reactIs_development.Portal;
  var reactIs_development_12 = reactIs_development.Profiler;
  var reactIs_development_13 = reactIs_development.StrictMode;
  var reactIs_development_14 = reactIs_development.Suspense;
  var reactIs_development_15 = reactIs_development.isValidElementType;
  var reactIs_development_16 = reactIs_development.isAsyncMode;
  var reactIs_development_17 = reactIs_development.isConcurrentMode;
  var reactIs_development_18 = reactIs_development.isContextConsumer;
  var reactIs_development_19 = reactIs_development.isContextProvider;
  var reactIs_development_20 = reactIs_development.isElement;
  var reactIs_development_21 = reactIs_development.isForwardRef;
  var reactIs_development_22 = reactIs_development.isFragment;
  var reactIs_development_23 = reactIs_development.isLazy;
  var reactIs_development_24 = reactIs_development.isMemo;
  var reactIs_development_25 = reactIs_development.isPortal;
  var reactIs_development_26 = reactIs_development.isProfiler;
  var reactIs_development_27 = reactIs_development.isStrictMode;
  var reactIs_development_28 = reactIs_development.isSuspense;

  var reactIs = createCommonjsModule(function (module) {

  if (process.env.NODE_ENV === 'production') {
    module.exports = reactIs_production_min;
  } else {
    module.exports = reactIs_development;
  }
  });

  /*
  object-assign
  (c) Sindre Sorhus
  @license MIT
  */
  /* eslint-disable no-unused-vars */
  var getOwnPropertySymbols = Object.getOwnPropertySymbols;
  var hasOwnProperty = Object.prototype.hasOwnProperty;
  var propIsEnumerable = Object.prototype.propertyIsEnumerable;

  function toObject(val) {
  	if (val === null || val === undefined) {
  		throw new TypeError('Object.assign cannot be called with null or undefined');
  	}

  	return Object(val);
  }

  function shouldUseNative() {
  	try {
  		if (!Object.assign) {
  			return false;
  		}

  		// Detect buggy property enumeration order in older V8 versions.

  		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
  		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
  		test1[5] = 'de';
  		if (Object.getOwnPropertyNames(test1)[0] === '5') {
  			return false;
  		}

  		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
  		var test2 = {};
  		for (var i = 0; i < 10; i++) {
  			test2['_' + String.fromCharCode(i)] = i;
  		}
  		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
  			return test2[n];
  		});
  		if (order2.join('') !== '0123456789') {
  			return false;
  		}

  		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
  		var test3 = {};
  		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
  			test3[letter] = letter;
  		});
  		if (Object.keys(Object.assign({}, test3)).join('') !==
  				'abcdefghijklmnopqrst') {
  			return false;
  		}

  		return true;
  	} catch (err) {
  		// We don't expect any of the above to throw, but better to be safe.
  		return false;
  	}
  }

  var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
  	var from;
  	var to = toObject(target);
  	var symbols;

  	for (var s = 1; s < arguments.length; s++) {
  		from = Object(arguments[s]);

  		for (var key in from) {
  			if (hasOwnProperty.call(from, key)) {
  				to[key] = from[key];
  			}
  		}

  		if (getOwnPropertySymbols) {
  			symbols = getOwnPropertySymbols(from);
  			for (var i = 0; i < symbols.length; i++) {
  				if (propIsEnumerable.call(from, symbols[i])) {
  					to[symbols[i]] = from[symbols[i]];
  				}
  			}
  		}
  	}

  	return to;
  };

  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

  var ReactPropTypesSecret_1 = ReactPropTypesSecret;

  var printWarning = function() {};

  if (process.env.NODE_ENV !== 'production') {
    var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
    var loggedTypeFailures = {};
    var has = Function.call.bind(Object.prototype.hasOwnProperty);

    printWarning = function(text) {
      var message = 'Warning: ' + text;
      if (typeof console !== 'undefined') {
        console.error(message);
      }
      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };
  }

  /**
   * Assert that the values match with the type specs.
   * Error messages are memorized and will only be shown once.
   *
   * @param {object} typeSpecs Map of name to a ReactPropType
   * @param {object} values Runtime values that need to be type-checked
   * @param {string} location e.g. "prop", "context", "child context"
   * @param {string} componentName Name of the component for error messages.
   * @param {?Function} getStack Returns the component stack.
   * @private
   */
  function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
    if (process.env.NODE_ENV !== 'production') {
      for (var typeSpecName in typeSpecs) {
        if (has(typeSpecs, typeSpecName)) {
          var error;
          // Prop type validation may throw. In case they do, we don't want to
          // fail the render phase where it didn't fail before. So we log it.
          // After these have been cleaned up, we'll let them throw.
          try {
            // This is intentionally an invariant that gets caught. It's the same
            // behavior as without this statement except with a better message.
            if (typeof typeSpecs[typeSpecName] !== 'function') {
              var err = Error(
                (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
                'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
              );
              err.name = 'Invariant Violation';
              throw err;
            }
            error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
          } catch (ex) {
            error = ex;
          }
          if (error && !(error instanceof Error)) {
            printWarning(
              (componentName || 'React class') + ': type specification of ' +
              location + ' `' + typeSpecName + '` is invalid; the type checker ' +
              'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
              'You may have forgotten to pass an argument to the type checker ' +
              'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
              'shape all require an argument).'
            );
          }
          if (error instanceof Error && !(error.message in loggedTypeFailures)) {
            // Only monitor this failure once because there tends to be a lot of the
            // same error.
            loggedTypeFailures[error.message] = true;

            var stack = getStack ? getStack() : '';

            printWarning(
              'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
            );
          }
        }
      }
    }
  }

  /**
   * Resets warning cache when testing.
   *
   * @private
   */
  checkPropTypes.resetWarningCache = function() {
    if (process.env.NODE_ENV !== 'production') {
      loggedTypeFailures = {};
    }
  };

  var checkPropTypes_1 = checkPropTypes;

  var has$1 = Function.call.bind(Object.prototype.hasOwnProperty);
  var printWarning$1 = function() {};

  if (process.env.NODE_ENV !== 'production') {
    printWarning$1 = function(text) {
      var message = 'Warning: ' + text;
      if (typeof console !== 'undefined') {
        console.error(message);
      }
      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };
  }

  function emptyFunctionThatReturnsNull() {
    return null;
  }

  var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
    /* global Symbol */
    var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
    var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

    /**
     * Returns the iterator method function contained on the iterable object.
     *
     * Be sure to invoke the function with the iterable as context:
     *
     *     var iteratorFn = getIteratorFn(myIterable);
     *     if (iteratorFn) {
     *       var iterator = iteratorFn.call(myIterable);
     *       ...
     *     }
     *
     * @param {?object} maybeIterable
     * @return {?function}
     */
    function getIteratorFn(maybeIterable) {
      var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
      if (typeof iteratorFn === 'function') {
        return iteratorFn;
      }
    }

    /**
     * Collection of methods that allow declaration and validation of props that are
     * supplied to React components. Example usage:
     *
     *   var Props = require('ReactPropTypes');
     *   var MyArticle = React.createClass({
     *     propTypes: {
     *       // An optional string prop named "description".
     *       description: Props.string,
     *
     *       // A required enum prop named "category".
     *       category: Props.oneOf(['News','Photos']).isRequired,
     *
     *       // A prop named "dialog" that requires an instance of Dialog.
     *       dialog: Props.instanceOf(Dialog).isRequired
     *     },
     *     render: function() { ... }
     *   });
     *
     * A more formal specification of how these methods are used:
     *
     *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
     *   decl := ReactPropTypes.{type}(.isRequired)?
     *
     * Each and every declaration produces a function with the same signature. This
     * allows the creation of custom validation functions. For example:
     *
     *  var MyLink = React.createClass({
     *    propTypes: {
     *      // An optional string or URI prop named "href".
     *      href: function(props, propName, componentName) {
     *        var propValue = props[propName];
     *        if (propValue != null && typeof propValue !== 'string' &&
     *            !(propValue instanceof URI)) {
     *          return new Error(
     *            'Expected a string or an URI for ' + propName + ' in ' +
     *            componentName
     *          );
     *        }
     *      }
     *    },
     *    render: function() {...}
     *  });
     *
     * @internal
     */

    var ANONYMOUS = '<<anonymous>>';

    // Important!
    // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
    var ReactPropTypes = {
      array: createPrimitiveTypeChecker('array'),
      bool: createPrimitiveTypeChecker('boolean'),
      func: createPrimitiveTypeChecker('function'),
      number: createPrimitiveTypeChecker('number'),
      object: createPrimitiveTypeChecker('object'),
      string: createPrimitiveTypeChecker('string'),
      symbol: createPrimitiveTypeChecker('symbol'),

      any: createAnyTypeChecker(),
      arrayOf: createArrayOfTypeChecker,
      element: createElementTypeChecker(),
      elementType: createElementTypeTypeChecker(),
      instanceOf: createInstanceTypeChecker,
      node: createNodeChecker(),
      objectOf: createObjectOfTypeChecker,
      oneOf: createEnumTypeChecker,
      oneOfType: createUnionTypeChecker,
      shape: createShapeTypeChecker,
      exact: createStrictShapeTypeChecker,
    };

    /**
     * inlined Object.is polyfill to avoid requiring consumers ship their own
     * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
     */
    /*eslint-disable no-self-compare*/
    function is(x, y) {
      // SameValue algorithm
      if (x === y) {
        // Steps 1-5, 7-10
        // Steps 6.b-6.e: +0 != -0
        return x !== 0 || 1 / x === 1 / y;
      } else {
        // Step 6.a: NaN == NaN
        return x !== x && y !== y;
      }
    }
    /*eslint-enable no-self-compare*/

    /**
     * We use an Error-like object for backward compatibility as people may call
     * PropTypes directly and inspect their output. However, we don't use real
     * Errors anymore. We don't inspect their stack anyway, and creating them
     * is prohibitively expensive if they are created too often, such as what
     * happens in oneOfType() for any type before the one that matched.
     */
    function PropTypeError(message) {
      this.message = message;
      this.stack = '';
    }
    // Make `instanceof Error` still work for returned errors.
    PropTypeError.prototype = Error.prototype;

    function createChainableTypeChecker(validate) {
      if (process.env.NODE_ENV !== 'production') {
        var manualPropTypeCallCache = {};
        var manualPropTypeWarningCount = 0;
      }
      function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
        componentName = componentName || ANONYMOUS;
        propFullName = propFullName || propName;

        if (secret !== ReactPropTypesSecret_1) {
          if (throwOnDirectAccess) {
            // New behavior only for users of `prop-types` package
            var err = new Error(
              'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
              'Use `PropTypes.checkPropTypes()` to call them. ' +
              'Read more at http://fb.me/use-check-prop-types'
            );
            err.name = 'Invariant Violation';
            throw err;
          } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
            // Old behavior for people using React.PropTypes
            var cacheKey = componentName + ':' + propName;
            if (
              !manualPropTypeCallCache[cacheKey] &&
              // Avoid spamming the console because they are often not actionable except for lib authors
              manualPropTypeWarningCount < 3
            ) {
              printWarning$1(
                'You are manually calling a React.PropTypes validation ' +
                'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
                'and will throw in the standalone `prop-types` package. ' +
                'You may be seeing this warning due to a third-party PropTypes ' +
                'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
              );
              manualPropTypeCallCache[cacheKey] = true;
              manualPropTypeWarningCount++;
            }
          }
        }
        if (props[propName] == null) {
          if (isRequired) {
            if (props[propName] === null) {
              return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
            }
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
          }
          return null;
        } else {
          return validate(props, propName, componentName, location, propFullName);
        }
      }

      var chainedCheckType = checkType.bind(null, false);
      chainedCheckType.isRequired = checkType.bind(null, true);

      return chainedCheckType;
    }

    function createPrimitiveTypeChecker(expectedType) {
      function validate(props, propName, componentName, location, propFullName, secret) {
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== expectedType) {
          // `propValue` being instance of, say, date/regexp, pass the 'object'
          // check, but we can offer a more precise error message here rather than
          // 'of type `object`'.
          var preciseType = getPreciseType(propValue);

          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createAnyTypeChecker() {
      return createChainableTypeChecker(emptyFunctionThatReturnsNull);
    }

    function createArrayOfTypeChecker(typeChecker) {
      function validate(props, propName, componentName, location, propFullName) {
        if (typeof typeChecker !== 'function') {
          return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
        }
        var propValue = props[propName];
        if (!Array.isArray(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
        }
        for (var i = 0; i < propValue.length; i++) {
          var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createElementTypeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        if (!isValidElement(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createElementTypeTypeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        if (!reactIs.isValidElementType(propValue)) {
          var propType = getPropType(propValue);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createInstanceTypeChecker(expectedClass) {
      function validate(props, propName, componentName, location, propFullName) {
        if (!(props[propName] instanceof expectedClass)) {
          var expectedClassName = expectedClass.name || ANONYMOUS;
          var actualClassName = getClassName(props[propName]);
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createEnumTypeChecker(expectedValues) {
      if (!Array.isArray(expectedValues)) {
        if (process.env.NODE_ENV !== 'production') {
          if (arguments.length > 1) {
            printWarning$1(
              'Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' +
              'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).'
            );
          } else {
            printWarning$1('Invalid argument supplied to oneOf, expected an array.');
          }
        }
        return emptyFunctionThatReturnsNull;
      }

      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        for (var i = 0; i < expectedValues.length; i++) {
          if (is(propValue, expectedValues[i])) {
            return null;
          }
        }

        var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
          var type = getPreciseType(value);
          if (type === 'symbol') {
            return String(value);
          }
          return value;
        });
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
      }
      return createChainableTypeChecker(validate);
    }

    function createObjectOfTypeChecker(typeChecker) {
      function validate(props, propName, componentName, location, propFullName) {
        if (typeof typeChecker !== 'function') {
          return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
        }
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
        }
        for (var key in propValue) {
          if (has$1(propValue, key)) {
            var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
            if (error instanceof Error) {
              return error;
            }
          }
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createUnionTypeChecker(arrayOfTypeCheckers) {
      if (!Array.isArray(arrayOfTypeCheckers)) {
        process.env.NODE_ENV !== 'production' ? printWarning$1('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
        return emptyFunctionThatReturnsNull;
      }

      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (typeof checker !== 'function') {
          printWarning$1(
            'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
            'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
          );
          return emptyFunctionThatReturnsNull;
        }
      }

      function validate(props, propName, componentName, location, propFullName) {
        for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
          var checker = arrayOfTypeCheckers[i];
          if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
            return null;
          }
        }

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
      }
      return createChainableTypeChecker(validate);
    }

    function createNodeChecker() {
      function validate(props, propName, componentName, location, propFullName) {
        if (!isNode(props[propName])) {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createShapeTypeChecker(shapeTypes) {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
        }
        for (var key in shapeTypes) {
          var checker = shapeTypes[key];
          if (!checker) {
            continue;
          }
          var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error) {
            return error;
          }
        }
        return null;
      }
      return createChainableTypeChecker(validate);
    }

    function createStrictShapeTypeChecker(shapeTypes) {
      function validate(props, propName, componentName, location, propFullName) {
        var propValue = props[propName];
        var propType = getPropType(propValue);
        if (propType !== 'object') {
          return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
        }
        // We need to check all keys in case some are required but missing from
        // props.
        var allKeys = objectAssign({}, props[propName], shapeTypes);
        for (var key in allKeys) {
          var checker = shapeTypes[key];
          if (!checker) {
            return new PropTypeError(
              'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
              '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
              '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
            );
          }
          var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error) {
            return error;
          }
        }
        return null;
      }

      return createChainableTypeChecker(validate);
    }

    function isNode(propValue) {
      switch (typeof propValue) {
        case 'number':
        case 'string':
        case 'undefined':
          return true;
        case 'boolean':
          return !propValue;
        case 'object':
          if (Array.isArray(propValue)) {
            return propValue.every(isNode);
          }
          if (propValue === null || isValidElement(propValue)) {
            return true;
          }

          var iteratorFn = getIteratorFn(propValue);
          if (iteratorFn) {
            var iterator = iteratorFn.call(propValue);
            var step;
            if (iteratorFn !== propValue.entries) {
              while (!(step = iterator.next()).done) {
                if (!isNode(step.value)) {
                  return false;
                }
              }
            } else {
              // Iterator will provide entry [k,v] tuples rather than values.
              while (!(step = iterator.next()).done) {
                var entry = step.value;
                if (entry) {
                  if (!isNode(entry[1])) {
                    return false;
                  }
                }
              }
            }
          } else {
            return false;
          }

          return true;
        default:
          return false;
      }
    }

    function isSymbol(propType, propValue) {
      // Native Symbol.
      if (propType === 'symbol') {
        return true;
      }

      // falsy value can't be a Symbol
      if (!propValue) {
        return false;
      }

      // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
      if (propValue['@@toStringTag'] === 'Symbol') {
        return true;
      }

      // Fallback for non-spec compliant Symbols which are polyfilled.
      if (typeof Symbol === 'function' && propValue instanceof Symbol) {
        return true;
      }

      return false;
    }

    // Equivalent of `typeof` but with special handling for array and regexp.
    function getPropType(propValue) {
      var propType = typeof propValue;
      if (Array.isArray(propValue)) {
        return 'array';
      }
      if (propValue instanceof RegExp) {
        // Old webkits (at least until Android 4.0) return 'function' rather than
        // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
        // passes PropTypes.object.
        return 'object';
      }
      if (isSymbol(propType, propValue)) {
        return 'symbol';
      }
      return propType;
    }

    // This handles more types than `getPropType`. Only used for error messages.
    // See `createPrimitiveTypeChecker`.
    function getPreciseType(propValue) {
      if (typeof propValue === 'undefined' || propValue === null) {
        return '' + propValue;
      }
      var propType = getPropType(propValue);
      if (propType === 'object') {
        if (propValue instanceof Date) {
          return 'date';
        } else if (propValue instanceof RegExp) {
          return 'regexp';
        }
      }
      return propType;
    }

    // Returns a string that is postfixed to a warning about an invalid type.
    // For example, "undefined" or "of type array"
    function getPostfixForTypeWarning(value) {
      var type = getPreciseType(value);
      switch (type) {
        case 'array':
        case 'object':
          return 'an ' + type;
        case 'boolean':
        case 'date':
        case 'regexp':
          return 'a ' + type;
        default:
          return type;
      }
    }

    // Returns class name of the object, if any.
    function getClassName(propValue) {
      if (!propValue.constructor || !propValue.constructor.name) {
        return ANONYMOUS;
      }
      return propValue.constructor.name;
    }

    ReactPropTypes.checkPropTypes = checkPropTypes_1;
    ReactPropTypes.resetWarningCache = checkPropTypes_1.resetWarningCache;
    ReactPropTypes.PropTypes = ReactPropTypes;

    return ReactPropTypes;
  };

  function emptyFunction() {}
  function emptyFunctionWithReset() {}
  emptyFunctionWithReset.resetWarningCache = emptyFunction;

  var factoryWithThrowingShims = function() {
    function shim(props, propName, componentName, location, propFullName, secret) {
      if (secret === ReactPropTypesSecret_1) {
        // It is still safe when called from React.
        return;
      }
      var err = new Error(
        'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
        'Use PropTypes.checkPropTypes() to call them. ' +
        'Read more at http://fb.me/use-check-prop-types'
      );
      err.name = 'Invariant Violation';
      throw err;
    }  shim.isRequired = shim;
    function getShim() {
      return shim;
    }  // Important!
    // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
    var ReactPropTypes = {
      array: shim,
      bool: shim,
      func: shim,
      number: shim,
      object: shim,
      string: shim,
      symbol: shim,

      any: shim,
      arrayOf: getShim,
      element: shim,
      elementType: shim,
      instanceOf: getShim,
      node: shim,
      objectOf: getShim,
      oneOf: getShim,
      oneOfType: getShim,
      shape: getShim,
      exact: getShim,

      checkPropTypes: emptyFunctionWithReset,
      resetWarningCache: emptyFunction
    };

    ReactPropTypes.PropTypes = ReactPropTypes;

    return ReactPropTypes;
  };

  var propTypes = createCommonjsModule(function (module) {
  /**
   * Copyright (c) 2013-present, Facebook, Inc.
   *
   * This source code is licensed under the MIT license found in the
   * LICENSE file in the root directory of this source tree.
   */

  if (process.env.NODE_ENV !== 'production') {
    var ReactIs = reactIs;

    // By explicitly using `prop-types` you are opting into new development behavior.
    // http://fb.me/prop-types-in-prod
    var throwOnDirectAccess = true;
    module.exports = factoryWithTypeCheckers(ReactIs.isElement, throwOnDirectAccess);
  } else {
    // By explicitly using `prop-types` you are opting into new production behavior.
    // http://fb.me/prop-types-in-prod
    module.exports = factoryWithThrowingShims();
  }
  });

  var _typeof$1 = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };











  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();





  var defineProperty = function (obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  };

  var NOTHING = typeof Symbol !== "undefined" ? Symbol("immer-nothing") : defineProperty({}, "immer-nothing", true);

  var DRAFTABLE = typeof Symbol !== "undefined" ? Symbol("immer-draftable") : "__$immer_draftable";

  var DRAFT_STATE = typeof Symbol !== "undefined" ? Symbol("immer-state") : "__$immer_state";

  function isDraft(value) {
      return !!value && !!value[DRAFT_STATE];
  }

  function isDraftable(value) {
      if (!value || (typeof value === "undefined" ? "undefined" : _typeof$1(value)) !== "object") return false;
      if (Array.isArray(value)) return true;
      var proto = Object.getPrototypeOf(value);
      if (!proto || proto === Object.prototype) return true;
      return !!value[DRAFTABLE] || !!value.constructor[DRAFTABLE];
  }

  var assign = Object.assign || function assign(target, value) {
      for (var key in value) {
          if (has$2(value, key)) {
              target[key] = value[key];
          }
      }
      return target;
  };

  var ownKeys = typeof Reflect !== "undefined" && Reflect.ownKeys ? Reflect.ownKeys : typeof Object.getOwnPropertySymbols !== "undefined" ? function (obj) {
      return Object.getOwnPropertyNames(obj).concat(Object.getOwnPropertySymbols(obj));
  } : Object.getOwnPropertyNames;

  function shallowCopy(base) {
      var invokeGetters = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (Array.isArray(base)) return base.slice();
      var clone = Object.create(Object.getPrototypeOf(base));
      ownKeys(base).forEach(function (key) {
          if (key === DRAFT_STATE) {
              return; // Never copy over draft state.
          }
          var desc = Object.getOwnPropertyDescriptor(base, key);
          if (desc.get) {
              if (!invokeGetters) {
                  throw new Error("Immer drafts cannot have computed properties");
              }
              desc.value = desc.get.call(base);
          }
          if (desc.enumerable) {
              clone[key] = desc.value;
          } else {
              Object.defineProperty(clone, key, {
                  value: desc.value,
                  writable: true,
                  configurable: true
              });
          }
      });
      return clone;
  }

  function each(value, cb) {
      if (Array.isArray(value)) {
          for (var i = 0; i < value.length; i++) {
              cb(i, value[i], value);
          }
      } else {
          ownKeys(value).forEach(function (key) {
              return cb(key, value[key], value);
          });
      }
  }

  function isEnumerable(base, prop) {
      return Object.getOwnPropertyDescriptor(base, prop).enumerable;
  }

  function has$2(thing, prop) {
      return Object.prototype.hasOwnProperty.call(thing, prop);
  }

  function is(x, y) {
      // From: https://github.com/facebook/fbjs/blob/c69904a511b900266935168223063dd8772dfc40/packages/fbjs/src/core/shallowEqual.js
      if (x === y) {
          return x !== 0 || 1 / x === 1 / y;
      } else {
          return x !== x && y !== y;
      }
  }

  /** Each scope represents a `produce` call. */
  var ImmerScope = function () {
      function ImmerScope(parent) {
          classCallCheck(this, ImmerScope);

          this.drafts = [];
          this.parent = parent;

          // Whenever the modified draft contains a draft from another scope, we
          // need to prevent auto-freezing so the unowned draft can be finalized.
          this.canAutoFreeze = true;

          // To avoid prototype lookups:
          this.patches = null;
      }

      createClass(ImmerScope, [{
          key: "usePatches",
          value: function usePatches(patchListener) {
              if (patchListener) {
                  this.patches = [];
                  this.inversePatches = [];
                  this.patchListener = patchListener;
              }
          }
      }, {
          key: "revoke",
          value: function revoke() {
              this.leave();
              this.drafts.forEach(_revoke);
              this.drafts = null; // Make draft-related methods throw.
          }
      }, {
          key: "leave",
          value: function leave() {
              if (this === ImmerScope.current) {
                  ImmerScope.current = this.parent;
              }
          }
      }]);
      return ImmerScope;
  }();

  ImmerScope.current = null;
  ImmerScope.enter = function () {
      return this.current = new ImmerScope(this.current);
  };

  function _revoke(draft) {
      draft[DRAFT_STATE].revoke();
  }

  // property descriptors are recycled to make sure we don't create a get and set closure per property,
  // but share them all instead
  var descriptors = {};

  function willFinalize(scope, result, isReplaced) {
      scope.drafts.forEach(function (draft) {
          draft[DRAFT_STATE].finalizing = true;
      });
      if (!isReplaced) {
          if (scope.patches) {
              markChangesRecursively(scope.drafts[0]);
          }
          // This is faster when we don't care about which attributes changed.
          markChangesSweep(scope.drafts);
      }
      // When a child draft is returned, look for changes.
      else if (isDraft(result) && result[DRAFT_STATE].scope === scope) {
              markChangesSweep(scope.drafts);
          }
  }

  function createProxy(base, parent) {
      var isArray = Array.isArray(base);
      var draft = clonePotentialDraft(base);
      each(draft, function (prop) {
          proxyProperty(draft, prop, isArray || isEnumerable(base, prop));
      });

      // See "proxy.js" for property documentation.
      var scope = parent ? parent.scope : ImmerScope.current;
      var state = {
          scope: scope,
          modified: false,
          finalizing: false, // es5 only
          finalized: false,
          assigned: {},
          parent: parent,
          base: base,
          draft: draft,
          copy: null,
          revoke: revoke,
          revoked: false // es5 only
      };

      createHiddenProperty(draft, DRAFT_STATE, state);
      scope.drafts.push(draft);
      return draft;
  }

  function revoke() {
      this.revoked = true;
  }

  function source(state) {
      return state.copy || state.base;
  }

  function _get(state, prop) {
      assertUnrevoked(state);
      var value = source(state)[prop];
      // Drafts are only created for proxyable values that exist in the base state.
      if (!state.finalizing && value === state.base[prop] && isDraftable(value)) {
          prepareCopy(state);
          return state.copy[prop] = createProxy(value, state);
      }
      return value;
  }

  function _set(state, prop, value) {
      assertUnrevoked(state);
      state.assigned[prop] = true;
      if (!state.modified) {
          if (is(source(state)[prop], value)) return;
          markChanged(state);
          prepareCopy(state);
      }
      state.copy[prop] = value;
  }

  function markChanged(state) {
      if (!state.modified) {
          state.modified = true;
          if (state.parent) markChanged(state.parent);
      }
  }

  function prepareCopy(state) {
      if (!state.copy) state.copy = clonePotentialDraft(state.base);
  }

  function clonePotentialDraft(base) {
      var state = base && base[DRAFT_STATE];
      if (state) {
          state.finalizing = true;
          var draft = shallowCopy(state.draft, true);
          state.finalizing = false;
          return draft;
      }
      return shallowCopy(base);
  }

  function proxyProperty(draft, prop, enumerable) {
      var desc = descriptors[prop];
      if (desc) {
          desc.enumerable = enumerable;
      } else {
          descriptors[prop] = desc = {
              configurable: true,
              enumerable: enumerable,
              get: function get$$1() {
                  return _get(this[DRAFT_STATE], prop);
              },
              set: function set$$1(value) {
                  _set(this[DRAFT_STATE], prop, value);
              }
          };
      }
      Object.defineProperty(draft, prop, desc);
  }

  function assertUnrevoked(state) {
      if (state.revoked === true) throw new Error("Cannot use a proxy that has been revoked. Did you pass an object from inside an immer function to an async process? " + JSON.stringify(source(state)));
  }

  // This looks expensive, but only proxies are visited, and only objects without known changes are scanned.
  function markChangesSweep(drafts) {
      // The natural order of drafts in the `scope` array is based on when they
      // were accessed. By processing drafts in reverse natural order, we have a
      // better chance of processing leaf nodes first. When a leaf node is known to
      // have changed, we can avoid any traversal of its ancestor nodes.
      for (var i = drafts.length - 1; i >= 0; i--) {
          var state = drafts[i][DRAFT_STATE];
          if (!state.modified) {
              if (Array.isArray(state.base)) {
                  if (hasArrayChanges(state)) markChanged(state);
              } else if (hasObjectChanges(state)) markChanged(state);
          }
      }
  }

  function markChangesRecursively(object) {
      if (!object || (typeof object === "undefined" ? "undefined" : _typeof$1(object)) !== "object") return;
      var state = object[DRAFT_STATE];
      if (!state) return;
      var base = state.base,
          draft = state.draft,
          assigned = state.assigned;

      if (!Array.isArray(object)) {
          // Look for added keys.
          Object.keys(draft).forEach(function (key) {
              // The `undefined` check is a fast path for pre-existing keys.
              if (base[key] === undefined && !has$2(base, key)) {
                  assigned[key] = true;
                  markChanged(state);
              } else if (!assigned[key]) {
                  // Only untouched properties trigger recursion.
                  markChangesRecursively(draft[key]);
              }
          });
          // Look for removed keys.
          Object.keys(base).forEach(function (key) {
              // The `undefined` check is a fast path for pre-existing keys.
              if (draft[key] === undefined && !has$2(draft, key)) {
                  assigned[key] = false;
                  markChanged(state);
              }
          });
      } else if (hasArrayChanges(state)) {
          markChanged(state);
          assigned.length = true;
          if (draft.length < base.length) {
              for (var i = draft.length; i < base.length; i++) {
                  assigned[i] = false;
              }
          } else {
              for (var _i = base.length; _i < draft.length; _i++) {
                  assigned[_i] = true;
              }
          }
          for (var _i2 = 0; _i2 < draft.length; _i2++) {
              // Only untouched indices trigger recursion.
              if (assigned[_i2] === undefined) markChangesRecursively(draft[_i2]);
          }
      }
  }

  function hasObjectChanges(state) {
      var base = state.base,
          draft = state.draft;

      // Search for added keys. Start at the back, because non-numeric keys
      // are ordered by time of definition on the object.

      var keys = Object.keys(draft);
      for (var i = keys.length - 1; i >= 0; i--) {
          // The `undefined` check is a fast path for pre-existing keys.
          if (base[keys[i]] === undefined && !has$2(base, keys[i])) {
              return true;
          }
      }

      // Since no keys have been added, we can compare lengths to know if an
      // object has been deleted.
      return keys.length !== Object.keys(base).length;
  }

  function hasArrayChanges(state) {
      var draft = state.draft;

      if (draft.length !== state.base.length) return true;
      // See #116
      // If we first shorten the length, our array interceptors will be removed.
      // If after that new items are added, result in the same original length,
      // those last items will have no intercepting property.
      // So if there is no own descriptor on the last position, we know that items were removed and added
      // N.B.: splice, unshift, etc only shift values around, but not prop descriptors, so we only have to check
      // the last one
      var descriptor = Object.getOwnPropertyDescriptor(draft, draft.length - 1);
      // descriptor can be null, but only for newly created sparse arrays, eg. new Array(10)
      if (descriptor && !descriptor.get) return true;
      // For all other cases, we don't have to compare, as they would have been picked up by the index setters
      return false;
  }

  function createHiddenProperty(target, prop, value) {
      Object.defineProperty(target, prop, {
          value: value,
          enumerable: false,
          writable: true
      });
  }



  var legacyProxy = Object.freeze({
  	willFinalize: willFinalize,
  	createProxy: createProxy
  });

  // Do nothing before being finalized.
  function willFinalize$1() {}

  function createProxy$1(base, parent) {
      var scope = parent ? parent.scope : ImmerScope.current;
      var state = {
          // Track which produce call this is associated with.
          scope: scope,
          // True for both shallow and deep changes.
          modified: false,
          // Used during finalization.
          finalized: false,
          // Track which properties have been assigned (true) or deleted (false).
          assigned: {},
          // The parent draft state.
          parent: parent,
          // The base state.
          base: base,
          // The base proxy.
          draft: null,
          // Any property proxies.
          drafts: {},
          // The base copy with any updated values.
          copy: null,
          // Called by the `produce` function.
          revoke: null
      };

      var _ref = Array.isArray(base) ? // [state] is used for arrays, to make sure the proxy is array-ish and not violate invariants,
      // although state itself is an object
      Proxy.revocable([state], arrayTraps) : Proxy.revocable(state, objectTraps),
          revoke = _ref.revoke,
          proxy = _ref.proxy;

      state.draft = proxy;
      state.revoke = revoke;

      scope.drafts.push(proxy);
      return proxy;
  }

  var objectTraps = {
      get: get$1,
      has: function has$$1(target, prop) {
          return prop in source$1(target);
      },
      ownKeys: function ownKeys$$1(target) {
          return Reflect.ownKeys(source$1(target));
      },

      set: set$1,
      deleteProperty: deleteProperty,
      getOwnPropertyDescriptor: getOwnPropertyDescriptor,
      defineProperty: function defineProperty() {
          throw new Error("Object.defineProperty() cannot be used on an Immer draft"); // prettier-ignore
      },
      getPrototypeOf: function getPrototypeOf(target) {
          return Object.getPrototypeOf(target.base);
      },
      setPrototypeOf: function setPrototypeOf() {
          throw new Error("Object.setPrototypeOf() cannot be used on an Immer draft"); // prettier-ignore
      }
  };

  var arrayTraps = {};
  each(objectTraps, function (key, fn) {
      arrayTraps[key] = function () {
          arguments[0] = arguments[0][0];
          return fn.apply(this, arguments);
      };
  });
  arrayTraps.deleteProperty = function (state, prop) {
      if (isNaN(parseInt(prop))) {
          throw new Error("Immer only supports deleting array indices"); // prettier-ignore
      }
      return objectTraps.deleteProperty.call(this, state[0], prop);
  };
  arrayTraps.set = function (state, prop, value) {
      if (prop !== "length" && isNaN(parseInt(prop))) {
          throw new Error("Immer only supports setting array indices and the 'length' property"); // prettier-ignore
      }
      return objectTraps.set.call(this, state[0], prop, value);
  };

  // returns the object we should be reading the current value from, which is base, until some change has been made
  function source$1(state) {
      return state.copy || state.base;
  }

  function get$1(state, prop) {
      if (prop === DRAFT_STATE) return state;
      var drafts = state.drafts;

      // Check for existing draft in unmodified state.

      if (!state.modified && has$2(drafts, prop)) {
          return drafts[prop];
      }

      var value = source$1(state)[prop];
      if (state.finalized || !isDraftable(value)) return value;

      // Check for existing draft in modified state.
      if (state.modified) {
          // Assigned values are never drafted. This catches any drafts we created, too.
          if (value !== state.base[prop]) return value;
          // Store drafts on the copy (when one exists).
          drafts = state.copy;
      }

      return drafts[prop] = createProxy$1(value, state);
  }

  function set$1(state, prop, value) {
      if (!state.modified) {
          // Optimize based on value's truthiness. Truthy values are guaranteed to
          // never be undefined, so we can avoid the `in` operator. Lastly, truthy
          // values may be drafts, but falsy values are never drafts.
          var isUnchanged = value ? is(state.base[prop], value) || value === state.drafts[prop] : is(state.base[prop], value) && prop in state.base;
          if (isUnchanged) return true;
          markChanged$1(state);
      }
      state.assigned[prop] = true;
      state.copy[prop] = value;
      return true;
  }

  function deleteProperty(state, prop) {
      // The `undefined` check is a fast path for pre-existing keys.
      if (state.base[prop] !== undefined || prop in state.base) {
          state.assigned[prop] = false;
          markChanged$1(state);
      }
      if (state.copy) delete state.copy[prop];
      return true;
  }

  function getOwnPropertyDescriptor(state, prop) {
      var owner = source$1(state);
      var desc = Reflect.getOwnPropertyDescriptor(owner, prop);
      if (desc) {
          desc.writable = true;
          desc.configurable = !Array.isArray(owner) || prop !== "length";
      }
      return desc;
  }

  function markChanged$1(state) {
      if (!state.modified) {
          state.modified = true;
          state.copy = assign(shallowCopy(state.base), state.drafts);
          state.drafts = null;
          if (state.parent) markChanged$1(state.parent);
      }
  }

  var modernProxy = Object.freeze({
  	willFinalize: willFinalize$1,
  	createProxy: createProxy$1
  });

  function generatePatches(state, basePath, patches, inversePatches) {
      Array.isArray(state.base) ? generateArrayPatches(state, basePath, patches, inversePatches) : generateObjectPatches(state, basePath, patches, inversePatches);
  }

  function generateArrayPatches(state, basePath, patches, inversePatches) {
      var base = state.base,
          copy = state.copy,
          assigned = state.assigned;

      // Reduce complexity by ensuring `base` is never longer.

      if (copy.length < base.length) {
          var _ref = [copy, base];
          base = _ref[0];
          copy = _ref[1];
          var _ref2 = [inversePatches, patches];
          patches = _ref2[0];
          inversePatches = _ref2[1];
      }

      var delta = copy.length - base.length;

      // Find the first replaced index.
      var start = 0;
      while (base[start] === copy[start] && start < base.length) {
          ++start;
      }

      // Find the last replaced index. Search from the end to optimize splice patches.
      var end = base.length;
      while (end > start && base[end - 1] === copy[end + delta - 1]) {
          --end;
      }

      // Process replaced indices.
      for (var i = start; i < end; ++i) {
          if (assigned[i] && copy[i] !== base[i]) {
              var path = basePath.concat([i]);
              patches.push({
                  op: "replace",
                  path: path,
                  value: copy[i]
              });
              inversePatches.push({
                  op: "replace",
                  path: path,
                  value: base[i]
              });
          }
      }

      var useRemove = end != base.length;
      var replaceCount = patches.length;

      // Process added indices.
      for (var _i = end + delta - 1; _i >= end; --_i) {
          var _path = basePath.concat([_i]);
          patches[replaceCount + _i - end] = {
              op: "add",
              path: _path,
              value: copy[_i]
          };
          if (useRemove) {
              inversePatches.push({
                  op: "remove",
                  path: _path
              });
          }
      }

      // One "replace" patch reverses all non-splicing "add" patches.
      if (!useRemove) {
          inversePatches.push({
              op: "replace",
              path: basePath.concat(["length"]),
              value: base.length
          });
      }
  }

  function generateObjectPatches(state, basePath, patches, inversePatches) {
      var base = state.base,
          copy = state.copy;

      each(state.assigned, function (key, assignedValue) {
          var origValue = base[key];
          var value = copy[key];
          var op = !assignedValue ? "remove" : key in base ? "replace" : "add";
          if (origValue === value && op === "replace") return;
          var path = basePath.concat(key);
          patches.push(op === "remove" ? { op: op, path: path } : { op: op, path: path, value: value });
          inversePatches.push(op === "add" ? { op: "remove", path: path } : op === "remove" ? { op: "add", path: path, value: origValue } : { op: "replace", path: path, value: origValue });
      });
  }

  function applyPatches(draft, patches) {
      for (var i = 0; i < patches.length; i++) {
          var patch = patches[i];
          var path = patch.path;

          if (path.length === 0 && patch.op === "replace") {
              draft = patch.value;
          } else {
              var base = draft;
              for (var _i2 = 0; _i2 < path.length - 1; _i2++) {
                  base = base[path[_i2]];
                  if (!base || (typeof base === "undefined" ? "undefined" : _typeof$1(base)) !== "object") throw new Error("Cannot apply patch, path doesn't resolve: " + path.join("/")); // prettier-ignore
              }
              var key = path[path.length - 1];
              switch (patch.op) {
                  case "replace":
                      base[key] = patch.value;
                      break;
                  case "add":
                      if (Array.isArray(base)) {
                          // TODO: support "foo/-" paths for appending to an array
                          base.splice(key, 0, patch.value);
                      } else {
                          base[key] = patch.value;
                      }
                      break;
                  case "remove":
                      if (Array.isArray(base)) {
                          base.splice(key, 1);
                      } else {
                          delete base[key];
                      }
                      break;
                  default:
                      throw new Error("Unsupported patch operation: " + patch.op);
              }
          }
      }
      return draft;
  }

  function verifyMinified() {}

  var configDefaults = {
      useProxies: typeof Proxy !== "undefined" && typeof Reflect !== "undefined",
      autoFreeze: typeof process !== "undefined" ? process.env.NODE_ENV !== "production" : verifyMinified.name === "verifyMinified",
      onAssign: null,
      onDelete: null,
      onCopy: null
  };

  var Immer = function () {
      function Immer(config) {
          classCallCheck(this, Immer);

          assign(this, configDefaults, config);
          this.setUseProxies(this.useProxies);
          this.produce = this.produce.bind(this);
      }

      createClass(Immer, [{
          key: "produce",
          value: function produce(base, recipe, patchListener) {
              var _this = this;

              // curried invocation
              if (typeof base === "function" && typeof recipe !== "function") {
                  var defaultBase = recipe;
                  recipe = base;

                  // prettier-ignore
                  return function () {
                      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                          args[_key - 1] = arguments[_key];
                      }

                      var base = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultBase;
                      return _this.produce(base, function (draft) {
                          var _recipe;

                          return (_recipe = recipe).call.apply(_recipe, [draft, draft].concat(args));
                      });
                  };
              }

              // prettier-ignore
              {
                  if (typeof recipe !== "function") throw new Error("if first argument is not a function, the second argument to produce should be a function");
                  if (patchListener !== undefined && typeof patchListener !== "function") throw new Error("the third argument of a producer should not be set or a function");
              }

              var result = void 0;

              // Only plain objects, arrays, and "immerable classes" are drafted.
              if (isDraftable(base)) {
                  var scope = ImmerScope.enter();
                  var proxy = this.createProxy(base);
                  var hasError = true;
                  try {
                      result = recipe.call(proxy, proxy);
                      hasError = false;
                  } finally {
                      // finally instead of catch + rethrow better preserves original stack
                      if (hasError) scope.revoke();else scope.leave();
                  }
                  if (result instanceof Promise) {
                      return result.then(function (result) {
                          scope.usePatches(patchListener);
                          return _this.processResult(result, scope);
                      }, function (error) {
                          scope.revoke();
                          throw error;
                      });
                  }
                  scope.usePatches(patchListener);
                  return this.processResult(result, scope);
              } else {
                  result = recipe(base);
                  if (result === undefined) return base;
                  return result !== NOTHING ? result : undefined;
              }
          }
      }, {
          key: "createDraft",
          value: function createDraft(base) {
              if (!isDraftable(base)) throw new Error("First argument to createDraft should be a plain object, an array, or an immerable object."); // prettier-ignore
              var scope = ImmerScope.enter();
              var proxy = this.createProxy(base);
              scope.leave();
              proxy[DRAFT_STATE].customDraft = true;
              return proxy;
          }
      }, {
          key: "finishDraft",
          value: function finishDraft(draft, patchListener) {
              if (!isDraft(draft)) throw new Error("First argument to finishDraft should be an object from createDraft."); // prettier-ignore
              var state = draft[DRAFT_STATE];
              if (!state.customDraft) throw new Error("The draft provided was not created using `createDraft`"); // prettier-ignore
              if (state.finalized) throw new Error("The draft provided was has already been finished"); // prettier-ignore
              // TODO: check if created with createDraft
              // TODO: check if not finsihed twice
              var scope = state.scope;

              scope.usePatches(patchListener);
              return this.processResult(undefined, scope);
          }
      }, {
          key: "setAutoFreeze",
          value: function setAutoFreeze(value) {
              this.autoFreeze = value;
          }
      }, {
          key: "setUseProxies",
          value: function setUseProxies(value) {
              this.useProxies = value;
              assign(this, value ? modernProxy : legacyProxy);
          }
      }, {
          key: "applyPatches",
          value: function applyPatches$$1(base, patches) {
              // Mutate the base state when a draft is passed.
              if (isDraft(base)) {
                  return applyPatches(base, patches);
              }
              // Otherwise, produce a copy of the base state.
              return this.produce(base, function (draft) {
                  return applyPatches(draft, patches);
              });
          }
          /** @internal */

      }, {
          key: "processResult",
          value: function processResult(result, scope) {
              var baseDraft = scope.drafts[0];
              var isReplaced = result !== undefined && result !== baseDraft;
              this.willFinalize(scope, result, isReplaced);
              if (isReplaced) {
                  if (baseDraft[DRAFT_STATE].modified) {
                      scope.revoke();
                      throw new Error("An immer producer returned a new value *and* modified its draft. Either return a new value *or* modify the draft."); // prettier-ignore
                  }
                  if (isDraftable(result)) {
                      // Finalize the result in case it contains (or is) a subset of the draft.
                      result = this.finalize(result, null, scope);
                  }
                  if (scope.patches) {
                      scope.patches.push({
                          op: "replace",
                          path: [],
                          value: result
                      });
                      scope.inversePatches.push({
                          op: "replace",
                          path: [],
                          value: baseDraft[DRAFT_STATE].base
                      });
                  }
              } else {
                  // Finalize the base draft.
                  result = this.finalize(baseDraft, [], scope);
              }
              scope.revoke();
              if (scope.patches) {
                  scope.patchListener(scope.patches, scope.inversePatches);
              }
              return result !== NOTHING ? result : undefined;
          }
          /**
           * @internal
           * Finalize a draft, returning either the unmodified base state or a modified
           * copy of the base state.
           */

      }, {
          key: "finalize",
          value: function finalize(draft, path, scope) {
              var _this2 = this;

              var state = draft[DRAFT_STATE];
              if (!state) {
                  if (Object.isFrozen(draft)) return draft;
                  return this.finalizeTree(draft, null, scope);
              }
              // Never finalize drafts owned by another scope.
              if (state.scope !== scope) {
                  return draft;
              }
              if (!state.modified) {
                  return state.base;
              }
              if (!state.finalized) {
                  state.finalized = true;
                  this.finalizeTree(state.draft, path, scope);

                  if (this.onDelete) {
                      // The `assigned` object is unreliable with ES5 drafts.
                      if (this.useProxies) {
                          var assigned = state.assigned;

                          for (var prop in assigned) {
                              if (!assigned[prop]) this.onDelete(state, prop);
                          }
                      } else {
                          var base = state.base,
                              copy = state.copy;

                          each(base, function (prop) {
                              if (!has$2(copy, prop)) _this2.onDelete(state, prop);
                          });
                      }
                  }
                  if (this.onCopy) {
                      this.onCopy(state);
                  }

                  // At this point, all descendants of `state.copy` have been finalized,
                  // so we can be sure that `scope.canAutoFreeze` is accurate.
                  if (this.autoFreeze && scope.canAutoFreeze) {
                      Object.freeze(state.copy);
                  }

                  if (path && scope.patches) {
                      generatePatches(state, path, scope.patches, scope.inversePatches);
                  }
              }
              return state.copy;
          }
          /**
           * @internal
           * Finalize all drafts in the given state tree.
           */

      }, {
          key: "finalizeTree",
          value: function finalizeTree(root, rootPath, scope) {
              var _this3 = this;

              var state = root[DRAFT_STATE];
              if (state) {
                  if (!this.useProxies) {
                      state.finalizing = true;
                      state.copy = shallowCopy(state.draft, true);
                      state.finalizing = false;
                  }
                  root = state.copy;
              }

              var needPatches = !!rootPath && !!scope.patches;
              var finalizeProperty = function finalizeProperty(prop, value, parent) {
                  if (value === parent) {
                      throw Error("Immer forbids circular references");
                  }

                  // In the `finalizeTree` method, only the `root` object may be a draft.
                  var isDraftProp = !!state && parent === root;

                  if (isDraft(value)) {
                      var path = isDraftProp && needPatches && !state.assigned[prop] ? rootPath.concat(prop) : null;

                      // Drafts owned by `scope` are finalized here.
                      value = _this3.finalize(value, path, scope);

                      // Drafts from another scope must prevent auto-freezing.
                      if (isDraft(value)) {
                          scope.canAutoFreeze = false;
                      }

                      // Preserve non-enumerable properties.
                      if (Array.isArray(parent) || isEnumerable(parent, prop)) {
                          parent[prop] = value;
                      } else {
                          Object.defineProperty(parent, prop, { value: value });
                      }

                      // Unchanged drafts are never passed to the `onAssign` hook.
                      if (isDraftProp && value === state.base[prop]) return;
                  }
                  // Unchanged draft properties are ignored.
                  else if (isDraftProp && is(value, state.base[prop])) {
                          return;
                      }
                      // Search new objects for unfinalized drafts. Frozen objects should never contain drafts.
                      else if (isDraftable(value) && !Object.isFrozen(value)) {
                              each(value, finalizeProperty);
                          }

                  if (isDraftProp && _this3.onAssign) {
                      _this3.onAssign(state, prop, value);
                  }
              };

              each(root, finalizeProperty);
              return root;
          }
      }]);
      return Immer;
  }();

  var immer = new Immer();

  /**
   * The `produce` function takes a value and a "recipe function" (whose
   * return value often depends on the base state). The recipe function is
   * free to mutate its first argument however it wants. All mutations are
   * only ever applied to a __copy__ of the base state.
   *
   * Pass only a function to create a "curried producer" which relieves you
   * from passing the recipe function every time.
   *
   * Only plain objects and arrays are made mutable. All other objects are
   * considered uncopyable.
   *
   * Note: This function is __bound__ to its `Immer` instance.
   *
   * @param {any} base - the initial state
   * @param {Function} producer - function that receives a proxy of the base state as first argument and which can be freely modified
   * @param {Function} patchListener - optional function that will be called with all the patches produced here
   * @returns {any} a new state, or the initial state if nothing was modified
   */
  var produce = immer.produce;
  /**
   * Pass true to automatically freeze all copies created by Immer.
   *
   * By default, auto-freezing is disabled in production.
   */
  var setAutoFreeze = immer.setAutoFreeze.bind(immer);

  /**
   * Pass true to use the ES2015 `Proxy` class when creating drafts, which is
   * always faster than using ES5 proxies.
   *
   * By default, feature detection is used, so calling this is rarely necessary.
   */
  var setUseProxies = immer.setUseProxies.bind(immer);

  /**
   * Apply an array of Immer patches to the first argument.
   *
   * This function is a producer, which means copy-on-write is in effect.
   */
  var applyPatches$1 = immer.applyPatches.bind(immer);

  /**
   * Create an Immer draft from the given base state, which may be a draft itself.
   * The draft can be modified until you finalize it with the `finishDraft` function.
   */
  var createDraft = immer.createDraft.bind(immer);

  /**
   * Finalize an Immer draft from a `createDraft` call, returning the base state
   * (if no changes were made) or a modified copy. The draft must *not* be
   * mutated afterwards.
   *
   * Pass a function as the 2nd argument to generate Immer patches based on the
   * changes that were made.
   */
  var finishDraft = immer.finishDraft.bind(immer);

  function isPromise(obj) {
    return !!obj && (_typeof(obj) === "object" || typeof obj === "function") && typeof obj.then === "function";
  }

  var ALL_ITEMS = undefined;
  var UNINITIALIZED = null;

  var UninitializedError =
  /*#__PURE__*/
  function (_Error) {
    _inherits(UninitializedError, _Error);

    function UninitializedError(name, item) {
      var _this;

      _classCallCheck(this, UninitializedError);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(UninitializedError).call(this));
      _this.uninitializedName = name;
      _this.uninitializedItem = item;
      return _this;
    }

    return UninitializedError;
  }(_wrapNativeSuper(Error));

  var shallowEqual = function shallowEqual(obj1, obj2) {
    var keys = Object.keys(obj1);
    return keys.length === Object.keys(obj2).length && keys.every(function (key) {
      return obj1[key] === obj2[key];
    });
  };

  function memoizeDeriver(select, derive) {
    var lastState = null;
    var lastValue = null;
    return function (getState, item) {
      var state = select(getState, item);

      if (!(lastState && shallowEqual(state, lastState))) {
        lastValue = derive(state);
      }

      lastState = state;
      return lastValue;
    };
  }

  var createStore = function createStore(defaultProps) {
    var NAME_COUNT = 0;
    var NAME_BITS = {}; // calculate changed bits for StoreContext, whose value is
    // { state, actions, register, read }

    function getChangedBits(_ref, _ref2) {
      var prevState = _ref.state;
      var nextState = _ref2.state;
      var mask = 0;

      for (var id in nextState) {
        if (prevState[id] !== nextState[id]) {
          mask |= NAME_BITS[id];
        }
      }

      return mask;
    } // get the observed bits (bitmask) for a given top-level name
    // note: every 32nd name will share a bitmask


    function getObservedBits(name, item) {
      if (NAME_BITS.hasOwnProperty(name)) {
        return NAME_BITS[name];
      } else {
        var bits = 1 << NAME_COUNT++;
        return NAME_BITS[name] = bits;
      }
    } // create context for sharing THIS store


    var StoreContext = React.createContext({}, getChangedBits); // Store component

    var Store =
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(Store, _React$Component);

      function Store(props) {
        var _this2;

        _classCallCheck(this, Store);

        _this2 = _possibleConstructorReturn(this, _getPrototypeOf(Store).call(this, props));

        _defineProperty(_assertThisInitialized(_this2), "register", function (actions) {
          Object.keys(actions).forEach(function (actionName) {
            var action = actions[actionName];

            if (!_this2.registry.hasOwnProperty(actionName)) {
              _this2.registry[actionName] = new Set();

              _this2.actions[actionName] = function () {
                for (var _len = arguments.length, payload = new Array(_len), _key = 0; _key < _len; _key++) {
                  payload[_key] = arguments[_key];
                }

                return _this2.dispatch(actionName, payload);
              };
            }

            _this2.registry[actionName].add(action);
          });
        });

        _defineProperty(_assertThisInitialized(_this2), "dispatch", function (actionName, payload, extraInfo) {
          var dispatchId = _this2._dispatchId++;

          if (_this2.registry.hasOwnProperty(actionName)) {
            // only provide a public Store interface to actions
            var store = {
              update: _this2.update,
              getState: _this2.getState,
              actions: _this2.actions,
              meta: _this2.meta // pass along related information for logging etc.

            };

            var info = _objectSpread({
              actionName: actionName,
              dispatchId: dispatchId
            }, extraInfo); // create an function to execute all handlers registered
            // for an action


            var action = function action(store) {
              for (var _len2 = arguments.length, payload = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                payload[_key2 - 1] = arguments[_key2];
              }

              var promises = [];

              _this2.registry[actionName].forEach(function (handler // Set.forEach for IE11
              ) {
                return promises.push(handler.apply(void 0, [store].concat(payload)));
              });

              return Promise.all(promises).then(function (values) {
                return Object.assign.apply(Object, [Object.defineProperty({}, "dispatchId", {
                  value: dispatchId,
                  enumerable: false
                })].concat(_toConsumableArray(values.map(function (v) {
                  return v || {};
                }))));
              }).catch(function (error) {
                if (error) {
                  if (!error.hasOwnProperty("dispatchId")) {
                    Object.defineProperty(error, "dispatchId", {
                      value: dispatchId,
                      enumerable: false
                    });
                  }
                }

                throw error;
              });
            }; // assemble middleware


            var middleware = function middleware(action, info) {
              return function (store) {
                for (var _len3 = arguments.length, payload = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                  payload[_key3 - 1] = arguments[_key3];
                }

                return action.apply(void 0, [store].concat(payload));
              };
            };

            if (_this2.props.middleware && _this2.props.middleware.length > 0) {
              middleware = function middleware(action, info) {
                return _this2.props.middleware.reduce(function (prevHandler, nextMiddleware) {
                  return nextMiddleware(prevHandler, info);
                }, action);
              };
            } // execute middleware-wrapped action


            return middleware(action, info).apply(void 0, [store].concat(_toConsumableArray(payload)));
          } else {
            if (process.env.NODE_ENV !== "production") {
              console.warn("Unregistered action ".concat(actionName, " dispatched"));
            }

            return Promise.resolve(null); // ignore undeclared actions
          }
        });

        _defineProperty(_assertThisInitialized(_this2), "getState", function (name, item) {
          // provide abstract public interface for read-only access state
          // (in case we change how we manage it. for example, we may use
          // react-cache when it supports invalidation).
          if (name) {
            if (item) {
              if (_this2.state.hasOwnProperty(name)) {
                return _this2.state[name][item];
              } else {
                return undefined;
              }
            } else {
              return _this2.state[name];
            }
          } else {
            return _this2.state;
          }
        });

        _defineProperty(_assertThisInitialized(_this2), "registerDerivedState", function (derivedState) {
          Object.keys(derivedState).forEach(function (name) {
            var deriver = derivedState[name];

            if (Array.isArray(deriver)) {
              _this2.derivedState[name] = memoizeDeriver.apply(void 0, _toConsumableArray(deriver));
            } else {
              _this2.derivedState[name] = deriver;
            }

            NAME_BITS[name] = 1073741823; // dependent on everything until first executed
          });
        });

        _defineProperty(_assertThisInitialized(_this2), "read", function (name) {
          var item = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : ALL_ITEMS;

          // short-circuit return when already initialized
          if (_this2.state.hasOwnProperty(name) && _this2.state[name] != UNINITIALIZED // eslint-disable-line eqeqeq
          ) {
              if (item === ALL_ITEMS) {
                return _this2.state[name];
              } else if (_this2.state[name].hasOwnProperty(item)) {
                return _this2.state[name][item];
              } // otherwise this.state[name][item] isn't initialized

            } // value isn't in store, check for derived state


          if (_this2.derivedState.hasOwnProperty(name)) {
            var mask = 0;

            var getState = function getState(name, item) {
              mask |= getObservedBits(name, item);

              var value = _this2.getState(name, item); // eslint-disable-next-line eqeqeq


              if (value == UNINITIALIZED) {
                throw new UninitializedError(name, item);
              } else {
                return value;
              }
            };

            try {
              var derivedValue = _this2.derivedState[name](getState, item);

              if (process.env.NODE_ENV !== "production") {
                if (isPromise(derivedValue)) {
                  console.error("derivedState state functions cannot be async, please do async work in actions");
                  throw new Error("Invalid derivedState");
                }
              }

              NAME_BITS[name] = mask; // update derivedState bitmask w/dependencies

              return derivedValue;
            } catch (error) {
              if (error instanceof UninitializedError) {
                name = error.uninitializedName;
                item = error.uninitializedItem;
              } else {
                throw error;
              }
            }
          } // get initialization action


          var actionName = _this2.props.initializers[name];

          if (!actionName) {
            if (item === ALL_ITEMS) {
              throw Error("Cannot use undefined ".concat(name, " without Store initializer for ").concat(name));
            } else {
              throw Error("Cannot use undefined ".concat(name, "[").concat(item, "] without Store initializer for ").concat(name, " with payload ").concat(item));
            }
          } // create temporary cache for pending initialization


          if (!_this2._pendingInitializations.hasOwnProperty(name)) {
            _this2._pendingInitializations[name] = {};
          }

          var cache = _this2._pendingInitializations[name]; // retrieve pending cache state for this item

          var cacheKeyForItem = item; // could be ALL_ITEMS (=== undefined)

          var value = cache[cacheKeyForItem];

          if (value === undefined || value === true && (!_this2.state.hasOwnProperty(name) || _this2.state[name] == UNINITIALIZED) // eslint-disable-line eqeqeq
          ) {
              // if there is no pending cache entry for this item
              // OR it resolved without error and state still uninitialized
              // warning: we may not want to be this lenient but it can be helpful
              // for signaling that a retry is worthwhile
              var promise = new Promise(function (resolve) {
                return (// avoid updating state during existing state transition by deferring dispatch
                  // until after promise is thrown and the calling render function exits.
                  // https://developer.mozilla.org/en-US/docs/Web/JavaScript/EventLoop#Zero_delays
                  setTimeout(resolve, 0)
                );
              }).then(function () {
                return _this2.dispatch(actionName, [item], {
                  initializing: name
                });
              }).then(function () {
                // eslint-disable-next-line eqeqeq
                if (_this2.state[name] == UNINITIALIZED) {
                  // prevent infinite loop with faulty initializer
                  if (item === ALL_ITEMS) {
                    console.error("Initializer ".concat(actionName, " didn't initialize ").concat(name, "]!"));

                    _this2.setState(function (prevState) {
                      return _objectSpread({}, prevState, _defineProperty({}, name, {}));
                    });
                  } else {
                    console.error("Initializer ".concat(actionName, "(").concat(item, ") didn't initialize ").concat(name, "[").concat(item, "]!"));

                    _this2.setState(function (prevState) {
                      return _objectSpread({}, prevState, _defineProperty({}, name, _objectSpread({}, prevState[name] || {}, _defineProperty({}, item, {}))));
                    });
                  }
                }
              }); // put pending promise in the cache

              cache[cacheKeyForItem] = promise; // suspend render and update cache when resolved

              throw promise.then(function (value) {
                cache[cacheKeyForItem] = true;
              }, function (error) {
                cache[cacheKeyForItem] = error;
              });
            } else {
            // item already in pending initialization cache
            if (isPromise(value)) {
              // re-suspend with pending initializer promise
              throw value;
            } else if (value === true) {
              // noop throw to trigger short-circuit/synchronous read
              throw Promise.resolve();
            } else {
              // throw initializer error to error boundary
              if (!value.hasOwnProperty("isInitializer")) {
                value = Object.defineProperty(value, "isInitializer", {
                  value: true,
                  enumerable: false
                });
              }

              var clear = function clear() {
                delete cache[cacheKeyForItem];
              };

              if (!value.hasOwnProperty("clear")) {
                value = Object.defineProperty(value, "clear", {
                  value: clear,
                  writable: true,
                  enumerable: false
                });
              } else {
                value.clear = clear;
              }

              throw value;
            }
          }
        });

        _defineProperty(_assertThisInitialized(_this2), "update", function (mutator) {
          return (// use immer copy-on-write (mutate draft) semantics to update current state
            new Promise(function (resolve) {
              var changes = [];
              var reverts = [];

              _this2.setState(function (prevState) {
                var nextState = produce(prevState, function (draftState) {
                  return mutator(draftState);
                }, function (p, r) {
                  changes.push.apply(changes, _toConsumableArray(p));
                  reverts.push.apply(reverts, _toConsumableArray(r));
                });
                return nextState;
              }, function () {
                return resolve({
                  changes: changes,
                  reverts: reverts
                });
              });
            })
          );
        });

        _this2.actions = {};
        _this2.registry = {};

        _this2.register(props.actions);

        if (props.initialState) {
          _this2.state = _objectSpread({}, props.initialState);
        } else {
          _this2.state = {};
        }

        _this2.derivedState = {};

        if (props.derivedState) {
          _this2.registerDerivedState(props.derivedState);
        } // meta state (api objects, etc.) -- mutable!


        _this2.meta = props.meta || {}; // internal tracking

        _this2._pendingInitializations = {};
        _this2._dispatchId = 1;
        return _this2;
      }

      _createClass(Store, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          if (this.props.setup) {
            this.actions[this.props.setup]();
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          if (this.props.teardown) {
            this.actions[this.props.teardown]();
          } // alert developer of an unmount during a pending initialization so they can
          // add the missing Suspense component


          if (process.env.NODE_ENV !== "production") if (Object.keys(this._pendingInitializations).length) {
            console.error("Store unmounted during initialization. Its subtree might be missing a Suspense or an ErrorBoundary component.");
          }
        }
      }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate() {
          var _this3 = this;

          // clear pending initializations if resolved after Store update
          Object.keys(this._pendingInitializations).forEach(function (name) {
            Object.keys(_this3._pendingInitializations[name]).forEach(function (item) {
              if (_this3._pendingInitializations[name][item] === true) {
                // only delete successfully resolved promises, leave
                // pending promises and errors
                delete _this3._pendingInitializations[name][item];

                if (!Object.keys(_this3._pendingInitializations[name]).length) {
                  delete _this3._pendingInitializations[name];
                }
              }
            });
          });
        }
      }, {
        key: "render",
        value: function render() {
          return React.createElement(StoreContext.Provider, {
            value: {
              state: this.state,
              actions: this.actions,
              register: this.register,
              read: this.read
            }
          }, this.props.children);
        }
      }]);

      return Store;
    }(React.Component);

    _defineProperty(Store, "propTypes", {
      actions: propTypes.object,
      initializers: propTypes.object,
      initialState: propTypes.object,
      derivedState: propTypes.object,
      setup: propTypes.string,
      teardown: propTypes.string,
      middleware: propTypes.arrayOf(propTypes.func),
      meta: propTypes.object
    });

    _defineProperty(Store, "defaultProps", defaultProps);

    var ErrorBoundary =
    /*#__PURE__*/
    function (_React$Component2) {
      _inherits(ErrorBoundary, _React$Component2);

      function ErrorBoundary() {
        var _getPrototypeOf2;

        var _this4;

        _classCallCheck(this, ErrorBoundary);

        for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          args[_key4] = arguments[_key4];
        }

        _this4 = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ErrorBoundary)).call.apply(_getPrototypeOf2, [this].concat(args)));

        _defineProperty(_assertThisInitialized(_this4), "state", {
          error: null
        });

        _defineProperty(_assertThisInitialized(_this4), "clearError", function () {
          if (_this4.state.error.isInitializer) {
            _this4.state.error.clear();
          }

          _this4.setState({
            error: null
          });
        });

        return _this4;
      }

      _createClass(ErrorBoundary, [{
        key: "componentDidCatch",
        value: function componentDidCatch(error, info) {
          // You can also do things like log the error to an error reporting service
          if (this.props.onError) {
            this.props.onError(error, info);
          }
        }
      }, {
        key: "render",
        value: function render() {
          var _this5 = this;

          if (this.state.error) {
            if (!this.props.errorType || this.state.error instanceof this.props.errorType) {
              return React.createElement(StoreContext.Consumer, null, function (store) {
                return _this5.props.fallback({
                  error: _this5.state.error,
                  state: store.state,
                  actions: store.actions,
                  clearError: _this5.clearError
                });
              });
            } else {
              throw this.state.error;
            }
          } else {
            return this.props.children;
          }
        }
      }], [{
        key: "getDerivedStateFromError",
        value: function getDerivedStateFromError(error) {
          // Update state so the next render will show the fallback UI.
          return {
            error: error
          };
        }
      }]);

      return ErrorBoundary;
    }(React.Component);

    _defineProperty(ErrorBoundary, "propTypes", {
      fallback: propTypes.func.isRequired,
      onError: propTypes.func,
      errorType: propTypes.object
    });

    var UseStore =
    /*#__PURE__*/
    function (_React$Component3) {
      _inherits(UseStore, _React$Component3);

      function UseStore() {
        _classCallCheck(this, UseStore);

        return _possibleConstructorReturn(this, _getPrototypeOf(UseStore).apply(this, arguments));
      }

      _createClass(UseStore, [{
        key: "render",
        value: function render() {
          var _this6 = this;

          return React.createElement(StoreContext.Consumer, {
            observedBits: this.props.name ? getObservedBits(this.props.name, this.props.item) : 0
          }, function (store) {
            return _this6.props.name ? _this6.props.children(store.read(_this6.props.name, _this6.props.item), store.actions) : _this6.props.children(store.actions);
          });
        }
      }]);

      return UseStore;
    }(React.Component);

    _defineProperty(UseStore, "propTypes", {
      name: propTypes.string,
      item: propTypes.oneOfType([propTypes.string, propTypes.number, propTypes.bool, propTypes.symbol])
    });

    var exports = {
      Store: Store,
      ErrorBoundary: ErrorBoundary,
      UseStore: UseStore
    };

    if (React.useContext) {
      var useStore = function useStore(name, item) {
        // jump through an ugly hoop to avoid warning about using
        // observedBits argument with Context hook as we wait for
        // react to provide a better solution to selective Context
        // updates. if this ever gives trouble, just don't use
        // observedBits as it just provides an optimization and
        // isn't strictly required
        var dispatcher = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentDispatcher.current;
        var store = dispatcher.useContext(StoreContext, name ? getObservedBits(name, item) : 0);

        if (name) {
          return [store.read(name, item), store.actions];
        } else {
          return store.actions;
        }
      };

      exports["useStore"] = useStore;
    }

    return exports;
  };

  function logToConsole(type, _ref3) {
    var actionName = _ref3.actionName,
        payload = _ref3.payload,
        dispatchId = _ref3.dispatchId,
        initializing = _ref3.initializing,
        changes = _ref3.changes,
        result = _ref3.result,
        error = _ref3.error;

    switch (type) {
      case "initializing":
        console.log("%c".concat(type, " %c").concat(initializing, "%c%s %cwith %c").concat(actionName), "font-weight: bold;", "color: green; font-weight: bold;", "color: black; font-weight: bold;", payload ? "[\"".concat(payload, "\"]") : "", "color: black; font-weight: normal;", "color: blue; font-weight: bold;");
        break;

      case "dispatch":
        console.group("[".concat(dispatchId, "] ").concat(type, " %c").concat(actionName, "%c"), "color: blue;", "color: black");
        payload.forEach(function (arg) {
          return arg != null && console.log(arg);
        });
        console.groupEnd();
        break;

      case "executed":
        console.group("[".concat(dispatchId, "] ").concat(type, " %c").concat(actionName, "%c"), "color: blue;", "color: black");
        Object.keys(result).length > 0 && console.log(result);
        console.groupEnd();
        break;

      case "update":
        console.group("[".concat(dispatchId, "] ").concat(type, " %cfrom %c").concat(actionName, "%c"), "font-weight: normal;", "color: blue;", "color: black");
        changes.forEach(function (patch) {
          if (patch.path.length > 1) {
            console.groupCollapsed("%c".concat(patch.op, " %c").concat(patch.path.slice(0, patch.path.length - 1), "%c[\"").concat(patch.path[patch.path.length - 1], "\"]"), "font-weight: normal; font-style: italic;", "color: green", "color: black");
          } else {
            console.groupCollapsed("%c".concat(patch.op, " %c").concat(patch.path[0]), "font-weight: normal; font-style: italic;", "color: green");
          }

          console.log(patch.value);
          console.groupEnd();
        });
        console.groupEnd();
        break;

      case "error":
        console.groupCollapsed("[".concat(dispatchId, "] %c").concat(type, " %cin %c").concat(actionName), "color: red", "color: black; font-weight: normal;", "color: black");
        console.log(error);
        console.groupEnd();
        break;

      default:
        console.groupCollapsed("%c".concat(type, " %c").concat(actionName), "color: lightgrey", "color: black");
        console.log({
          actionName: actionName,
          payload: payload,
          dispatchId: dispatchId
        });
        console.groupEnd();
    }
  }

  var consoleLogger = function consoleLogger(action, _ref4) {
    var actionName = _ref4.actionName,
        initializing = _ref4.initializing,
        dispatchId = _ref4.dispatchId;
    return (
      /*#__PURE__*/
      function () {
        var _ref5 = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(store) {
          var _len5,
              payload,
              _key5,
              loggingStore,
              result,
              _args = arguments;

          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  for (_len5 = _args.length, payload = new Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
                    payload[_key5 - 1] = _args[_key5];
                  }

                  if (initializing) {
                    logToConsole("initializing", {
                      dispatchId: dispatchId,
                      actionName: actionName,
                      payload: payload,
                      initializing: initializing
                    });
                  }

                  loggingStore = _objectSpread({}, store, {
                    update: function update(mutator) {
                      return store.update(mutator).then(function (updateInfo) {
                        logToConsole("update", _objectSpread({
                          dispatchId: dispatchId,
                          actionName: actionName,
                          payload: payload
                        }, updateInfo));
                        return updateInfo;
                      });
                    }
                  });
                  logToConsole("dispatch", {
                    dispatchId: dispatchId,
                    actionName: actionName,
                    payload: payload
                  });
                  _context.prev = 4;
                  _context.next = 7;
                  return action.apply(void 0, [loggingStore].concat(payload));

                case 7:
                  result = _context.sent;
                  logToConsole("executed", {
                    dispatchId: dispatchId,
                    actionName: actionName,
                    payload: payload,
                    result: result || {}
                  });
                  return _context.abrupt("return", result);

                case 12:
                  _context.prev = 12;
                  _context.t0 = _context["catch"](4);
                  logToConsole("error", {
                    dispatchId: dispatchId,
                    actionName: actionName,
                    payload: payload,
                    error: _context.t0
                  });
                  throw _context.t0;

                case 16:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[4, 12]]);
        }));

        return function (_x) {
          return _ref5.apply(this, arguments);
        };
      }()
    );
  };

  exports.consoleLogger = consoleLogger;
  exports.default = createStore;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
